
#include <objbase.h>
#include "clsid.h"
#include "ilst41.h"	

class CLst41;


class CLst41I : public ILst41
{
  public:

    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID * ppvObj);
    STDMETHOD_(ULONG, AddRef)(THIS);
    STDMETHOD_(ULONG, Release)(THIS);
 
    STDMETHOD_(BSTR, GetMachineName)(THIS);
		
    CLst41*	m_pLst41;   
};


class CLst41 : public IUnknown 
{
	
 public:
    CLst41();
    ~CLst41();
    static CLst41* Create();

    STDMETHOD(QueryInterface)(REFIID riid, void** ppv);
    STDMETHOD_(ULONG, AddRef)(void);
    STDMETHOD_(ULONG, Release)(void);
	                                     
 private:
    ULONG m_refs;			// Reference count.
    IUnknown* m_disp_interface;	// Pointer to the standard dispatch object.
    CLst41I* m_prog_interface;  // What a programmer sees.
};


class CLst41CF : public IClassFactory 
{
  public:
    CLst41CF(); 
    static IClassFactory * Create();
	
    STDMETHOD(QueryInterface)(REFIID riid, void ** ppv);
    STDMETHOD_(ULONG, AddRef)(void);
    STDMETHOD_(ULONG, Release)(void);

    STDMETHOD(CreateInstance)(	IUnknown * punkOuter, 
				REFIID riid, 
				void ** ppv);
    STDMETHOD(LockServer)(BOOL fLock);

  private:
    ULONG m_refs;
};
